package dev.shadowsoffire.apotheosis.mixin;

import org.spongepowered.asm.mixin.injection.callback.LocalCapture;
import net.minecraft.world.entity.item.ItemEntity;
import java.util.function.Supplier;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.TelepathicAffix;
import net.minecraft.world.phys.Vec3;
import java.util.function.Predicate;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.Entity;
import javax.annotation.Nullable;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.Block;
import org.spongepowered.asm.mixin.Mixin;
import dev.shadowsoffire.apotheosis.ench.api.IEnchantingBlock;

@Mixin({ Block.class })
public abstract class BlockMixin implements IEnchantingBlock
{
    @Inject(at = { @At("HEAD") }, method = { "dropResources(Lnet/minecraft/world/level/block/state/BlockState;Lnet/minecraft/world/level/Level;Lnet/minecraft/core/BlockPos;Lnet/minecraft/world/level/block/entity/BlockEntity;Lnet/minecraft/world/entity/Entity;Lnet/minecraft/world/item/ItemStack;Z)V" }, remap = false)
    private static void apoth_telepathicHead(final BlockState pState, final Level pLevel, final BlockPos pPos, @Nullable final BlockEntity pBlockEntity, @Nullable final Entity pEntity, final ItemStack pTool, final boolean dropXp, final CallbackInfo ci) {
        if (pEntity != null && AffixHelper.getAffixes(pTool).values().stream().anyMatch(AffixInstance::enablesTelepathy)) {
            TelepathicAffix.blockDropTargetPos = new Vec3(pEntity.m_20185_(), pEntity.m_20186_(), pEntity.m_20189_());
        }
    }
    
    @Inject(at = { @At("TAIL") }, method = { "dropResources(Lnet/minecraft/world/level/block/state/BlockState;Lnet/minecraft/world/level/Level;Lnet/minecraft/core/BlockPos;Lnet/minecraft/world/level/block/entity/BlockEntity;Lnet/minecraft/world/entity/Entity;Lnet/minecraft/world/item/ItemStack;Z)V" }, remap = false)
    private static void apoth_telepathicTail(final BlockState pState, final Level pLevel, final BlockPos pPos, @Nullable final BlockEntity pBlockEntity, @Nullable final Entity pEntity, final ItemStack pTool, final boolean dropXp, final CallbackInfo ci) {
        TelepathicAffix.blockDropTargetPos = null;
    }
    
    @Inject(at = { @At(value = "INVOKE", target = "net/minecraft/world/level/Level.addFreshEntity(Lnet/minecraft/world/entity/Entity;)Z") }, method = { "popResource(Lnet/minecraft/world/level/Level;Ljava/util/function/Supplier;Lnet/minecraft/world/item/ItemStack;)V" }, locals = LocalCapture.CAPTURE_FAILHARD)
    private static void apoth_telepathicTP(final Level pLevel, final Supplier<ItemEntity> pItemEntitySupplier, final ItemStack pStack, final CallbackInfo ci, final ItemEntity itemEntity) {
        if (TelepathicAffix.blockDropTargetPos != null) {
            itemEntity.m_146884_(TelepathicAffix.blockDropTargetPos);
            itemEntity.m_32010_(0);
        }
    }
}
